<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/Python/SXRGenerator.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/Python/SXRGenerator.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/Python/SXRGenerator.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">import</span> parser</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">import</span> token</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">import</span> tokenize</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">import</span> symbol</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">import</span> keyword</span>
<a id="line13"></a><span class="lineno"> 13</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line">HAVE_ENCODING_DECL = hasattr(symbol, <span class="py-string">&quot;encoding_decl&quot;</span>) <span class="py-comment"># python 2.3</span></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">HAVE_IMPORT_NAME = hasattr(symbol, <span class="py-string">&quot;import_name&quot;</span>) <span class="py-comment"># python 2.4</span></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">HAVE_DECORATOR = hasattr(symbol,<span class="py-string">&quot;decorator&quot;</span>) <span class="py-comment"># python 2.4</span></span>
<a id="line17"></a><span class="lineno"> 17</span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator.html#num_tokens">num_tokens</a>(ptree):</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Count the number of leaf tokens in the given ptree.&quot;&quot;&quot;</span></span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">    <span class="py-keyword">if</span> type(ptree) == str: <span class="py-keyword">return</span> 1</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    <span class="py-keyword">else</span>: <span class="py-keyword">return</span> sum([num_tokens(n) <span class="py-keyword">for</span> n <span class="py-keyword">in</span> ptree[1:]])</span>
<a id="line23"></a><span class="lineno"> 23</span>
<a id="line24"></a><span class="lineno"> 24</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/LexerDebugger.html">LexerDebugger</a>:</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/LexerDebugger.html#__init__">__init__</a>(self, lexer):</span>
<a id="line28"></a><span class="lineno"> 28</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">        self.lexer = lexer</span>
<a id="line30"></a><span class="lineno"> 30</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/LexerDebugger.html#next">next</a>(self):</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">        n = self.lexer.next()</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-keyword">print</span> <span class="py-string">'next is &quot;%s&quot; (%s)'</span>%(n[1], n[0])</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">        <span class="py-keyword">return</span> n</span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">header=<span class="py-string">&quot;&quot;&quot;&lt;sxr filename=&quot;%(filename)s&quot;&gt;</span></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">&lt;line&gt;&quot;&quot;&quot;</span></span>
<a id="line39"></a><span class="lineno"> 39</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">trailer=<span class="py-string">&quot;&quot;&quot;&lt;/line&gt;</span></span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line"><span class="py-string">&lt;/sxr&gt;</span></span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line"><span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator.html#escape">escape</a>(text):</span>
<a id="line45"></a><span class="lineno"> 45</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">    <span class="py-keyword">for</span> p <span class="py-keyword">in</span> [(<span class="py-string">'&amp;'</span>, <span class="py-string">'&amp;amp;'</span>), (<span class="py-string">'&quot;'</span>, <span class="py-string">'&amp;quot;'</span>), (<span class="py-string">'&lt;'</span>, <span class="py-string">'&amp;lt;'</span>), (<span class="py-string">'&gt;'</span>, <span class="py-string">'&amp;gt;'</span>),]:</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">        text = text.replace(*p)</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">    <span class="py-keyword">return</span> text</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html">SXRGenerator</a>:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">    <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line53"></a><span class="lineno"> 53</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#__init__">__init__</a>(self):</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">        <span class="py-string">&quot;&quot;&quot;&quot;&quot;&quot;</span></span>
<a id="line56"></a><span class="lineno"> 56</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">        self.handlers = {}</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">        self.handlers[token.ENDMARKER] = self.handle_end_marker</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        self.handlers[token.NEWLINE] = self.handle_newline</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">        self.handlers[token.INDENT] = self.handle_indent</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        self.handlers[token.DEDENT] = self.handle_dedent</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        self.handlers[token.STRING] = self.handle_string</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">        self.handlers[symbol.funcdef]= self.handle_function</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">        self.handlers[symbol.parameters] = self.handle_parameters</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        self.handlers[symbol.classdef] = self.handle_class</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">        self.handlers[token.NAME] = self.handle_name</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        self.handlers[symbol.expr_stmt] = self.handle_expr_stmt</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">        <span class="py-comment">#self.handlers[token.OP] = self.handle_op</span></span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        self.handlers[symbol.power] = self.handle_power</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        <span class="py-keyword">if</span> HAVE_ENCODING_DECL:</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">            self.handlers[symbol.encoding_decl] = self.handle_encoding_decl</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">        <span class="py-keyword">if</span> HAVE_IMPORT_NAME:</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">            self.handlers[symbol.import_as_names] = self.handle_import_as_names</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">            self.handlers[symbol.dotted_as_names] = self.handle_dotted_as_names</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">            self.handlers[symbol.import_from] = self.handle_import_from</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">            self.handlers[symbol.import_name] = self.handle_import_name</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">            self.handlers[symbol.import_stmt] = self.handle_import</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">        <span class="py-keyword">if</span> HAVE_DECORATOR:</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">            self.handlers[symbol.decorator] = self.handle_decorator</span>
<a id="line81"></a><span class="lineno"> 81</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        self.col = 0</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        self.lineno = 1</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">        self.parameters = []</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        self.scopes = []</span>
<a id="line86"></a><span class="lineno"> 86</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#process_file">process_file</a>(self, scope, sourcefile, sxr):</span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        self.scopes = list(scope)</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">        input = open(sourcefile.abs_name, <span class="py-string">'r+'</span>)</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        src = input.readlines()</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">        self.lines = len(`len(src) + 1`)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        ptree = parser.ast2tuple(parser.suite(<span class="py-string">''</span>.join(src)))</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">        input.seek(0)</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">        self.lexer = tokenize.generate_tokens(input.readline)</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        <span class="py-comment">#self.lexer = LexerDebugger(tokenize.generate_tokens(input.readline))</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        self.sxr = open(sxr, <span class="py-string">'w+'</span>)</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        lineno_template = <span class="py-string">'%%%ds'</span> % self.lines</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        lineno = lineno_template % self.lineno</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        self.sxr.write(header % {<span class="py-string">'filename'</span>: sourcefile.name})</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-keyword">try</span>:</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">            self.handle(ptree)</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-keyword">except</span> StopIteration:</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            <span class="py-keyword">raise</span></span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        self.sxr.write(trailer)</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">        self.sxr.close()</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">        self.scopes.pop()</span>
<a id="line108"></a><span class="lineno">108</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle">handle</a>(self, ptree):</span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        <span class="py-keyword">if</span> type(ptree) == tuple:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">            kind = ptree[0]</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            value = ptree[1:]</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">            handler = self.handlers.get(kind, self.default_handler)</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">            handler(value)</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            <span class="py-keyword">raise</span> Exception(<span class="py-string">&quot;Process error: Type is not a tuple %s&quot;</span> % str(ptree))</span>
<a id="line118"></a><span class="lineno">118</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#default_handler">default_handler</a>(self, ptree):</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        <span class="py-keyword">for</span> node <span class="py-keyword">in</span> ptree:</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">            <span class="py-keyword">if</span> type(node) == tuple: self.handle(node)</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            <span class="py-keyword">elif</span> type(node) == str: self.handle_token(node)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">            <span class="py-keyword">else</span>: <span class="py-keyword">raise</span> Exception(<span class="py-string">&quot;Invalid ptree node&quot;</span>)</span>
<a id="line126"></a><span class="lineno">126</span>
<a id="line127"></a><span class="lineno">127</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#next_token">next_token</a>(self):</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Return the next visible token.</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line"><span class="py-string">        Process tokens that are not part of the parse tree silently.&quot;&quot;&quot;</span></span>
<a id="line131"></a><span class="lineno">131</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        t = self.lexer.next()</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        <span class="py-keyword">while</span> t[0] <span class="py-keyword">in</span> [tokenize.NL, tokenize.COMMENT]:</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">            <span class="py-keyword">if</span> t[0] <span class="py-keyword">is</span> tokenize.NL:</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">                self.print_newline()</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">            <span class="py-keyword">elif</span> t[0] <span class="py-keyword">is</span> tokenize.COMMENT:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">                self.print_token(t)</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">                <span class="py-keyword">if</span> t[1][-1] == <span class="py-string">'\n'</span>: self.print_newline()</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">            t = self.lexer.next()</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-keyword">return</span> t</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_token">handle_token</a>(self, item = None):</span>
<a id="line144"></a><span class="lineno">144</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        t = self.next_token()</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">        <span class="py-keyword">if</span> item <span class="py-keyword">is</span> <span class="py-keyword">not</span> None <span class="py-keyword">and</span> t[1] != item:</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">            <span class="py-keyword">raise</span> <span class="py-string">'Internal error in line %d: expected &quot;%s&quot;, got &quot;%s&quot; (%d)'</span>%(self.lineno, item, t[1], t[0])</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">            self.print_token(t)</span>
<a id="line150"></a><span class="lineno">150</span>
<a id="line151"></a><span class="lineno">151</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_name_as_xref">handle_name_as_xref</a>(self, xref, name, from_ = None, type = None):</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">        kind, value, (srow, scol), (erow, ecol), line = self.next_token()</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">        <span class="py-keyword">if</span> (kind, value) != (token.NAME, name):</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">            <span class="py-keyword">raise</span> <span class="py-string">'Internal error in line %d: expected name &quot;%s&quot;, got &quot;%s&quot; (%d)'</span>%(name, self.lineno, item, t[1], t[0])</span>
<a id="line157"></a><span class="lineno">157</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">        <span class="py-keyword">if</span> self.col != scol:</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">            self.sxr.write(<span class="py-string">' '</span> * (scol - self.col))</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        attrs = []</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-keyword">if</span> from_: attrs.append(<span class="py-string">'from=&quot;%s&quot;'</span>%from_)</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        <span class="py-keyword">if</span> type: attrs.append(<span class="py-string">'type=&quot;%s&quot;'</span>%type)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        a = <span class="py-string">'&lt;a href=&quot;%s&quot; %s&gt;%s&lt;/a&gt;'</span>%(<span class="py-string">'.'</span>.join(xref), <span class="py-string">' '</span>.join(attrs), value)</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">        self.sxr.write(a)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        self.col = ecol</span>
<a id="line166"></a><span class="lineno">166</span>
<a id="line167"></a><span class="lineno">167</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_tokens">handle_tokens</a>(self, ptree):</span>
<a id="line169"></a><span class="lineno">169</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        tokens = num_tokens(ptree)</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> xrange(tokens):</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">            self.handle_token()</span>
<a id="line173"></a><span class="lineno">173</span>
<a id="line174"></a><span class="lineno">174</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_end_marker">handle_end_marker</a>(self, nodes): <span class="py-keyword">pass</span></span>
<a id="line176"></a><span class="lineno">176</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_newline">handle_newline</a>(self, nodes):</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        self.handle_token()</span>
<a id="line179"></a><span class="lineno">179</span>
<a id="line180"></a><span class="lineno">180</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_indent">handle_indent</a>(self, indent):</span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        self.handle_token()</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_dedent">handle_dedent</a>(self, dedent):</span>
<a id="line187"></a><span class="lineno">187</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        self.handle_token()</span>
<a id="line189"></a><span class="lineno">189</span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_string">handle_string</a>(self, content):</span>
<a id="line192"></a><span class="lineno">192</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">        self.handle_token()</span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_function">handle_function</a>(self, nodes):</span>
<a id="line197"></a><span class="lineno">197</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">        <span class="py-keyword">if</span> HAVE_DECORATOR:</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">            <span class="py-keyword">if</span> nodes[0][0] == symbol.decorators:</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">                offset = 1</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">                <span class="py-comment"># FIXME</span></span>
<a id="line202"></a><span class="lineno">202</span><span class="line">                self.handle(nodes[0])</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">                offset = 0</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">            offset = 0</span>
<a id="line207"></a><span class="lineno">207</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        def_token = nodes[0 + offset]</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">        self.handle_token(def_token[1])</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">        name = nodes[1 + offset][1]</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">        qname = tuple(self.scopes + [name])</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">        self.handle_name_as_xref(qname, name, from_=<span class="py-string">'.'</span>.join(self.scopes), type=<span class="py-string">'definition'</span>)</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">        <span class="py-comment"># Handle the parameters.</span></span>
<a id="line214"></a><span class="lineno">214</span><span class="line">        self.handle(nodes[2 + offset])</span>
<a id="line215"></a><span class="lineno">215</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">        colon_token = nodes[3 + offset]</span>
<a id="line217"></a><span class="lineno">217</span><span class="line">        self.handle_token(colon_token[1])</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        body = nodes[4 + offset]</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">        <span class="py-comment"># Theoretically, we'd have to push the function scope here.</span></span>
<a id="line220"></a><span class="lineno">220</span><span class="line">        <span class="py-comment"># Practically, however, we don't inject xrefs (yet) into function bodies.</span></span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        self.handle_tokens(body)</span>
<a id="line222"></a><span class="lineno">222</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">        <span class="py-comment"># Don't traverse the function body, since the ASG doesn't handle</span></span>
<a id="line224"></a><span class="lineno">224</span><span class="line">        <span class="py-comment"># local declarations anyways.</span></span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_parameters">handle_parameters</a>(self, nodes):</span>
<a id="line228"></a><span class="lineno">228</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">        self.handle_token(nodes[0][1])</span>
<a id="line230"></a><span class="lineno">230</span><span class="line">        <span class="py-keyword">if</span> nodes[1][0] == symbol.varargslist:</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">            args = list(nodes[1][1:])</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">            <span class="py-keyword">while</span> args:</span>
<a id="line233"></a><span class="lineno">233</span><span class="line">                <span class="py-keyword">if</span> args[0][0] == token.COMMA:</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line235"></a><span class="lineno">235</span><span class="line">                    <span class="py-keyword">pass</span></span>
<a id="line236"></a><span class="lineno">236</span><span class="line">                <span class="py-keyword">elif</span> args[0][0] == symbol.fpdef:</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">                    self.handle_tokens(args[0])</span>
<a id="line238"></a><span class="lineno">238</span><span class="line">                <span class="py-keyword">elif</span> args[0][0] == token.EQUAL:</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">                    <span class="py-keyword">del</span> args[0]</span>
<a id="line241"></a><span class="lineno">241</span><span class="line">                    self.handle_tokens(args[0])</span>
<a id="line242"></a><span class="lineno">242</span><span class="line">                <span class="py-keyword">elif</span> args[0][0] == token.DOUBLESTAR:</span>
<a id="line243"></a><span class="lineno">243</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line244"></a><span class="lineno">244</span><span class="line">                    <span class="py-keyword">del</span> args[0]</span>
<a id="line245"></a><span class="lineno">245</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line246"></a><span class="lineno">246</span><span class="line">                <span class="py-keyword">elif</span> args[0][0] == token.STAR:</span>
<a id="line247"></a><span class="lineno">247</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line248"></a><span class="lineno">248</span><span class="line">                    <span class="py-keyword">del</span> args[0]</span>
<a id="line249"></a><span class="lineno">249</span><span class="line">                    self.handle_token(args[0][1])</span>
<a id="line250"></a><span class="lineno">250</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line251"></a><span class="lineno">251</span><span class="line">                    <span class="py-keyword">print</span> <span class="py-string">&quot;Unknown symbol:&quot;</span>,args[0]</span>
<a id="line252"></a><span class="lineno">252</span><span class="line">                <span class="py-keyword">del</span> args[0]</span>
<a id="line253"></a><span class="lineno">253</span><span class="line">        self.handle_token(nodes[-1][1])</span>
<a id="line254"></a><span class="lineno">254</span>
<a id="line255"></a><span class="lineno">255</span>
<a id="line256"></a><span class="lineno">256</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_class">handle_class</a>(self, nodes):</span>
<a id="line257"></a><span class="lineno">257</span>
<a id="line258"></a><span class="lineno">258</span><span class="line">        class_token = nodes[0]</span>
<a id="line259"></a><span class="lineno">259</span><span class="line">        self.handle_token(class_token[1])</span>
<a id="line260"></a><span class="lineno">260</span><span class="line">        name = nodes[1][1]</span>
<a id="line261"></a><span class="lineno">261</span><span class="line">        qname = tuple(self.scopes + [name])</span>
<a id="line262"></a><span class="lineno">262</span><span class="line">        self.handle_name_as_xref(qname, name, from_=<span class="py-string">'.'</span>.join(self.scopes), type=<span class="py-string">'definition'</span>)</span>
<a id="line263"></a><span class="lineno">263</span><span class="line">        base_clause = nodes[2][0] == token.LPAR <span class="py-keyword">and</span> nodes[3] <span class="py-keyword">or</span> None</span>
<a id="line264"></a><span class="lineno">264</span><span class="line">        self.handle_tokens(nodes[2])</span>
<a id="line265"></a><span class="lineno">265</span><span class="line">        bases = []</span>
<a id="line266"></a><span class="lineno">266</span><span class="line">        <span class="py-keyword">if</span> base_clause:</span>
<a id="line267"></a><span class="lineno">267</span><span class="line">            self.handle_tokens(base_clause)</span>
<a id="line268"></a><span class="lineno">268</span><span class="line">            self.handle_token(<span class="py-string">')'</span>)</span>
<a id="line269"></a><span class="lineno">269</span><span class="line">            self.handle_token(<span class="py-string">':'</span>)</span>
<a id="line270"></a><span class="lineno">270</span>
<a id="line271"></a><span class="lineno">271</span><span class="line">            body = nodes[6]</span>
<a id="line272"></a><span class="lineno">272</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line273"></a><span class="lineno">273</span><span class="line">            body = nodes[3]</span>
<a id="line274"></a><span class="lineno">274</span><span class="line">        self.scopes.append(name)</span>
<a id="line275"></a><span class="lineno">275</span><span class="line">        self.handle(body)</span>
<a id="line276"></a><span class="lineno">276</span><span class="line">        self.scopes.pop()</span>
<a id="line277"></a><span class="lineno">277</span>
<a id="line278"></a><span class="lineno">278</span>
<a id="line279"></a><span class="lineno">279</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_name">handle_name</a>(self, content):</span>
<a id="line280"></a><span class="lineno">280</span>
<a id="line281"></a><span class="lineno">281</span><span class="line">        self.handle_token(content[0])</span>
<a id="line282"></a><span class="lineno">282</span>
<a id="line283"></a><span class="lineno">283</span>
<a id="line284"></a><span class="lineno">284</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_expr_stmt">handle_expr_stmt</a>(self, nodes):</span>
<a id="line285"></a><span class="lineno">285</span>
<a id="line286"></a><span class="lineno">286</span><span class="line">        <span class="py-keyword">for</span> n <span class="py-keyword">in</span> nodes: self.handle_tokens(n)</span>
<a id="line287"></a><span class="lineno">287</span>
<a id="line288"></a><span class="lineno">288</span>
<a id="line289"></a><span class="lineno">289</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_dotted_name">handle_dotted_name</a>(self, dname, rest):</span>
<a id="line290"></a><span class="lineno">290</span>
<a id="line291"></a><span class="lineno">291</span><span class="line">        self.handle_token(dname[0])</span>
<a id="line292"></a><span class="lineno">292</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> dname[1:]:</span>
<a id="line293"></a><span class="lineno">293</span><span class="line">            self.handle_token(<span class="py-string">'.'</span>)</span>
<a id="line294"></a><span class="lineno">294</span><span class="line">            self.handle_token(name)</span>
<a id="line295"></a><span class="lineno">295</span><span class="line">        map(self.handle, rest)</span>
<a id="line296"></a><span class="lineno">296</span>
<a id="line297"></a><span class="lineno">297</span>
<a id="line298"></a><span class="lineno">298</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_op">handle_op</a>(self, nodes): <span class="py-keyword">pass</span></span>
<a id="line299"></a><span class="lineno">299</span>
<a id="line300"></a><span class="lineno">300</span>
<a id="line301"></a><span class="lineno">301</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_power">handle_power</a>(self, content):</span>
<a id="line302"></a><span class="lineno">302</span>
<a id="line303"></a><span class="lineno">303</span><span class="line">        <span class="py-keyword">def</span> get_dotted_name(content):</span>
<a id="line304"></a><span class="lineno">304</span><span class="line">            <span class="py-keyword">if</span> content[0][0] != symbol.atom <span class="py-keyword">or</span> content[0][1][0] != token.NAME:</span>
<a id="line305"></a><span class="lineno">305</span><span class="line">                <span class="py-keyword">return</span> None</span>
<a id="line306"></a><span class="lineno">306</span><span class="line">            dotted_name = [content[0][1][1]]</span>
<a id="line307"></a><span class="lineno">307</span><span class="line">            i = 1</span>
<a id="line308"></a><span class="lineno">308</span><span class="line">            <span class="py-keyword">for</span> param <span class="py-keyword">in</span> content[1:]:</span>
<a id="line309"></a><span class="lineno">309</span><span class="line">                <span class="py-keyword">if</span> param[0] != symbol.trailer: <span class="py-keyword">break</span></span>
<a id="line310"></a><span class="lineno">310</span><span class="line">                <span class="py-keyword">if</span> param[1][0] != token.DOT: <span class="py-keyword">break</span></span>
<a id="line311"></a><span class="lineno">311</span><span class="line">                <span class="py-keyword">if</span> param[2][0] != token.NAME: <span class="py-keyword">break</span></span>
<a id="line312"></a><span class="lineno">312</span><span class="line">                dotted_name.append(param[2][1])</span>
<a id="line313"></a><span class="lineno">313</span><span class="line">                i += 1</span>
<a id="line314"></a><span class="lineno">314</span><span class="line">            <span class="py-keyword">if</span> i &lt; len(content): <span class="py-keyword">return</span> dotted_name, content[i:]</span>
<a id="line315"></a><span class="lineno">315</span><span class="line">            <span class="py-keyword">else</span>: <span class="py-keyword">return</span> dotted_name, []</span>
<a id="line316"></a><span class="lineno">316</span>
<a id="line317"></a><span class="lineno">317</span><span class="line">        name = get_dotted_name(content)</span>
<a id="line318"></a><span class="lineno">318</span><span class="line">        <span class="py-keyword">if</span> name: self.handle_dotted_name(*name)</span>
<a id="line319"></a><span class="lineno">319</span><span class="line">        <span class="py-keyword">else</span>: map(self.handle, content)</span>
<a id="line320"></a><span class="lineno">320</span>
<a id="line321"></a><span class="lineno">321</span>
<a id="line322"></a><span class="lineno">322</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_encoding_decl">handle_encoding_decl</a>(self, nodes):</span>
<a id="line323"></a><span class="lineno">323</span>
<a id="line324"></a><span class="lineno">324</span><span class="line">        <span class="py-comment"># For some reason the encoding is the last tuple item</span></span>
<a id="line325"></a><span class="lineno">325</span><span class="line">        <span class="py-keyword">for</span> n <span class="py-keyword">in</span> nodes[:-1]: self.handle(n)</span>
<a id="line326"></a><span class="lineno">326</span>
<a id="line327"></a><span class="lineno">327</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_import_as_names">handle_import_as_names</a>(self, nodes):</span>
<a id="line328"></a><span class="lineno">328</span>
<a id="line329"></a><span class="lineno">329</span><span class="line">        <span class="py-keyword">for</span> n <span class="py-keyword">in</span> nodes: self.handle(n)</span>
<a id="line330"></a><span class="lineno">330</span>
<a id="line331"></a><span class="lineno">331</span>
<a id="line332"></a><span class="lineno">332</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_dotted_as_names">handle_dotted_as_names</a>(self, nodes):</span>
<a id="line333"></a><span class="lineno">333</span>
<a id="line334"></a><span class="lineno">334</span><span class="line">        <span class="py-keyword">for</span> n <span class="py-keyword">in</span> nodes: self.handle(n)</span>
<a id="line335"></a><span class="lineno">335</span>
<a id="line336"></a><span class="lineno">336</span>
<a id="line337"></a><span class="lineno">337</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_import_from">handle_import_from</a>(self, nodes):</span>
<a id="line338"></a><span class="lineno">338</span>
<a id="line339"></a><span class="lineno">339</span><span class="line">        self.handle_token(<span class="py-string">'from'</span>)</span>
<a id="line340"></a><span class="lineno">340</span><span class="line">        self.handle(nodes[1])</span>
<a id="line341"></a><span class="lineno">341</span><span class="line">        self.handle_token(<span class="py-string">'import'</span>)</span>
<a id="line342"></a><span class="lineno">342</span><span class="line">        self.handle(nodes[3])</span>
<a id="line343"></a><span class="lineno">343</span>
<a id="line344"></a><span class="lineno">344</span>
<a id="line345"></a><span class="lineno">345</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_import_name">handle_import_name</a>(self, nodes):</span>
<a id="line346"></a><span class="lineno">346</span>
<a id="line347"></a><span class="lineno">347</span><span class="line">        self.handle_token(<span class="py-string">'import'</span>)</span>
<a id="line348"></a><span class="lineno">348</span><span class="line">        self.handle_dotted_as_names(nodes[1][1:])</span>
<a id="line349"></a><span class="lineno">349</span>
<a id="line350"></a><span class="lineno">350</span>
<a id="line351"></a><span class="lineno">351</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_import">handle_import</a>(self, nodes):</span>
<a id="line352"></a><span class="lineno">352</span>
<a id="line353"></a><span class="lineno">353</span><span class="line">        <span class="py-comment">#self.handle_token('import')</span></span>
<a id="line354"></a><span class="lineno">354</span><span class="line">        <span class="py-keyword">for</span> n <span class="py-keyword">in</span> nodes: self.handle(n)</span>
<a id="line355"></a><span class="lineno">355</span>
<a id="line356"></a><span class="lineno">356</span>
<a id="line357"></a><span class="lineno">357</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#handle_decorator">handle_decorator</a>(self, nodes): <span class="py-keyword">pass</span></span>
<a id="line358"></a><span class="lineno">358</span>
<a id="line359"></a><span class="lineno">359</span>
<a id="line360"></a><span class="lineno">360</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#print_token">print_token</a>(self, t):</span>
<a id="line361"></a><span class="lineno">361</span>
<a id="line362"></a><span class="lineno">362</span><span class="line">        kind, value, (srow, scol), (erow, ecol), line = t</span>
<a id="line363"></a><span class="lineno">363</span><span class="line">        <span class="py-keyword">if</span> kind == token.NEWLINE:</span>
<a id="line364"></a><span class="lineno">364</span><span class="line">            self.print_newline()</span>
<a id="line365"></a><span class="lineno">365</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line366"></a><span class="lineno">366</span><span class="line">            <span class="py-keyword">if</span> self.col != scol:</span>
<a id="line367"></a><span class="lineno">367</span><span class="line">                self.sxr.write(<span class="py-string">' '</span> * (scol - self.col))</span>
<a id="line368"></a><span class="lineno">368</span><span class="line">            <span class="py-keyword">if</span> keyword.iskeyword(value):</span>
<a id="line369"></a><span class="lineno">369</span><span class="line">                format = <span class="py-string">'&lt;span class=&quot;py-keyword&quot;&gt;%s&lt;/span&gt;'</span></span>
<a id="line370"></a><span class="lineno">370</span><span class="line">            <span class="py-keyword">elif</span> kind == token.STRING:</span>
<a id="line371"></a><span class="lineno">371</span><span class="line">                format = <span class="py-string">'&lt;span class=&quot;py-string&quot;&gt;%s&lt;/span&gt;'</span></span>
<a id="line372"></a><span class="lineno">372</span><span class="line">                chunks = value.split(<span class="py-string">'\n'</span>)</span>
<a id="line373"></a><span class="lineno">373</span><span class="line">                <span class="py-keyword">for</span> c <span class="py-keyword">in</span> chunks[:-1]:</span>
<a id="line374"></a><span class="lineno">374</span><span class="line">                    self.sxr.write(format % escape(c))</span>
<a id="line375"></a><span class="lineno">375</span><span class="line">                    self.print_newline()</span>
<a id="line376"></a><span class="lineno">376</span><span class="line">                value = chunks[-1]</span>
<a id="line377"></a><span class="lineno">377</span>
<a id="line378"></a><span class="lineno">378</span><span class="line">            <span class="py-keyword">elif</span> kind == tokenize.COMMENT:</span>
<a id="line379"></a><span class="lineno">379</span><span class="line">                format = <span class="py-string">'&lt;span class=&quot;py-comment&quot;&gt;%s&lt;/span&gt;'</span></span>
<a id="line380"></a><span class="lineno">380</span><span class="line">                <span class="py-keyword">if</span> value[-1] == <span class="py-string">'\n'</span>: value = value[:-1]</span>
<a id="line381"></a><span class="lineno">381</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line382"></a><span class="lineno">382</span><span class="line">                format = <span class="py-string">'%s'</span></span>
<a id="line383"></a><span class="lineno">383</span>
<a id="line384"></a><span class="lineno">384</span><span class="line">            self.sxr.write(format % escape(value))</span>
<a id="line385"></a><span class="lineno">385</span><span class="line">            self.col = ecol</span>
<a id="line386"></a><span class="lineno">386</span>
<a id="line387"></a><span class="lineno">387</span>
<a id="line388"></a><span class="lineno">388</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/SXRGenerator/SXRGenerator.html#print_newline">print_newline</a>(self):</span>
<a id="line389"></a><span class="lineno">389</span>
<a id="line390"></a><span class="lineno">390</span><span class="line">        self.col = 0</span>
<a id="line391"></a><span class="lineno">391</span><span class="line">        self.lineno += 1</span>
<a id="line392"></a><span class="lineno">392</span><span class="line">        self.sxr.write(<span class="py-string">'&lt;/line&gt;\n'</span>)</span>
<a id="line393"></a><span class="lineno">393</span><span class="line">        self.sxr.write(<span class="py-string">'&lt;line&gt;'</span>)</span>
<a id="line394"></a><span class="lineno">394</span>
<a id="line395"></a><span class="lineno">395</span>
<a id="line396"></a><span class="lineno">396</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:16 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
